# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Bifurcation is the python interface to namespace Bifurcation
of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.Bifurcation is to provide strategies for creating
bifurcation objects.  The python version of LOCA.Bifurcation supports
the following classes:

    * Factory  - Factory for creating bifurcation strategy objects

"""


from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_Bifurcation')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_Bifurcation')
    _Bifurcation = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Bifurcation', [dirname(__file__)])
        except ImportError:
            import _Bifurcation
            return _Bifurcation
        try:
            _mod = imp.load_module('_Bifurcation', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _Bifurcation = swig_import_helper()
    del swig_import_helper
else:
    import _Bifurcation
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

try:
    import weakref
    weakref_proxy = weakref.proxy
except __builtin__.Exception:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    from . import MultiContinuation
else:
    import MultiContinuation
del _swig_python_version_info
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import Extended
from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    from . import Parameter
else:
    import Parameter
del _swig_python_version_info
class Factory(_object):
    """


    Factory for creating bifurcation strategy objects.

    The parameters passed to the create() through the bifurcationParams
    argument method should specify the "Type" and "Formulation" as
    described below, as well as any additional parameters for the
    particular strategy. "Type" - Name of the bifurcation type. Valid
    choices are "None" - No bifurcation [Default]

    "Turning Point" Turning point bifurations

    "Pitchfork" Pitchfork bifurcations

    "Hopf" Hopf bifurcations

    "Phase Transition" Phase Transition points

    "User-Defined" User defined bifurcation. Set "User-Defined Name"
    to be the parameter list name containing user-defined strategy, which
    must be of type Teuchos::RCP<LOCA::MultiContinuation::AbstractGroup>.

    "Formulation" - Name of the bifurcation formulation. Valid choices
    are For turning point bifurcations: "Moore-Spence" [Default] (
    LOCA::TurningPoint::MooreSpence::ExtendedGroup)

    "Minimally Augmented" (
    LOCA::TurningPoint::MinimallyAugmented::ExtendedGroup)

    For pitchfork bifurcations: "Moore-Spence" [Default] (
    LOCA::Pitchfork::MooreSpence::ExtendedGroup)

    "Minimally Augmented" (
    LOCA::Pitchfork::MinimallyAugmented::ExtendedGroup)

    For Hopf bifurcations: "Moore-Spence" [Default] (
    LOCA::Hopf::MooreSpence::ExtendedGroup)

    "Minimally Augmented" (
    LOCA::Hopf::MinimallyAugmented::ExtendedGroup)

    C++ includes: LOCA_Bifurcation_Factory.H 
    """

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Factory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Factory, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        """
        __init__(LOCA::Bifurcation::Factory self, Teuchos::RCP< LOCA::GlobalData > const & global_data) -> Factory

        LOCA::Bifurcation::Factory::Factory(const Teuchos::RCP<
        LOCA::GlobalData > &global_data)

        Constructor. 
        """
        this = _Bifurcation.new_Factory(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _Bifurcation.delete_Factory

    def create(self, *args):
        """
        create(Factory self, Teuchos::RCP< LOCA::Parameter::SublistParser > const & topParams, Teuchos::RCP< Teuchos::ParameterList > const & bifurcationParams, Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup > const & grp) -> Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >

        Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >
        LOCA::Bifurcation::Factory::create(const Teuchos::RCP<
        LOCA::Parameter::SublistParser > &topParams, const Teuchos::RCP<
        Teuchos::ParameterList > &bifurcationParams, const Teuchos::RCP<
        LOCA::MultiContinuation::AbstractGroup > &grp)

        Create bifurcation strategy.

        Parameters:
        -----------

        topParams:  [in] Parsed top-level parameter list.

        bifurcationParams:  [in] Bifurcation parameters as described above

        grp:  [in] Underlying group 
        """
        return _Bifurcation.Factory_create(self, *args)


    def strategyName(self, *args):
        """
        strategyName(Factory self, ParameterList bifurcationParams) -> std::string

        std::string
        LOCA::Bifurcation::Factory::strategyName(Teuchos::ParameterList
        &bifurcationParams) const

        Return strategy name given by bifurcationParams. 
        """
        return _Bifurcation.Factory_strategyName(self, *args)

Factory_swigregister = _Bifurcation.Factory_swigregister
Factory_swigregister(Factory)

# This file is compatible with both classic and new-style classes.


