# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Parameter is the python interface to namespace
Parameter of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.Parameter is to provide a centralized library for
setting/retrieving numerical parameter values in application codes.
The python version of LOCA.Parameter supports the following classes:

    * Library  - Class to provide a centralized library for setting/retrieving
                 numerical parameter values in application codes

"""


from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_Parameter')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_Parameter')
    _Parameter = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Parameter', [dirname(__file__)])
        except ImportError:
            import _Parameter
            return _Parameter
        try:
            _mod = imp.load_module('_Parameter', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _Parameter = swig_import_helper()
    del swig_import_helper
else:
    import _Parameter
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

try:
    import weakref
    weakref_proxy = weakref.proxy
except __builtin__.Exception:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
class Library(_object):
    """


    Class to provide a centralized library for setting/retrieving
    numerical parameter values in application codes.

    This class provides a mechanism for setting and retrieving arbitrary
    numerical parameter values throughout an application code. Parameters
    can be material properties, coefficients in source functions, etc. The
    purpose of this class is to allow external libraries to set and
    retrieve parameters values to perform, for example, numerical
    continuation and optimization.

    This class in currently under development and is far from complete.

    C++ includes: LOCA_Parameter_Library.H 
    """

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Library, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Library, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        """
        __init__(LOCA::Parameter::Library self) -> Library

        LOCA::Parameter::Library::Library()

        Default constructor. 
        """
        this = _Parameter.new_Library(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _Parameter.delete_Library
Library_swigregister = _Parameter.Library_swigregister
Library_swigregister(Library)

class ParameterVector(_object):
    """


    LOCA's container for holding a set of parameters that are used by the
    LOCA continuation routines.

    Roger Pawlowski (SNL 9233)

    C++ includes: LOCA_Parameter_Vector.H 
    """

    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterVector, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        """
        __init__(LOCA::ParameterVector self) -> ParameterVector
        __init__(LOCA::ParameterVector self, ParameterVector source) -> ParameterVector

        LOCA::ParameterVector::ParameterVector(const ParameterVector &source)

        Copy constructor. 
        """
        this = _Parameter.new_ParameterVector(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this

    def clone(self, *args):
        """
        clone(ParameterVector self) -> ParameterVector

        LOCA::ParameterVector * LOCA::ParameterVector::clone() const

        Clone. 
        """
        return _Parameter.ParameterVector_clone(self, *args)

    __swig_destroy__ = _Parameter.delete_ParameterVector

    def addParameter(self, *args):
        """
        addParameter(ParameterVector self, std::string label, double value=0.0) -> int

        int
        LOCA::ParameterVector::addParameter(std::string label, double
        value=0.0)

        Adds a parameter to the list. Returns the index value assigned to the
        parameter. 
        """
        return _Parameter.ParameterVector_addParameter(self, *args)


    def init(self, *args):
        """
        init(ParameterVector self, double value) -> bool

        bool
        LOCA::ParameterVector::init(double value)

        Initialize the vector. Returns true if successful. 
        """
        return _Parameter.ParameterVector_init(self, *args)


    def scale(self, *args):
        """
        scale(ParameterVector self, double value) -> bool
        scale(ParameterVector self, ParameterVector p) -> bool

        bool
        LOCA::ParameterVector::scale(const ParameterVector &p)

        Scales the vactor with another vector (element-wise multiply). Returns
        true if successful. 
        """
        return _Parameter.ParameterVector_scale(self, *args)


    def update(self, *args):
        """
        update(ParameterVector self, double alpha, ParameterVector alphaVector, double b) -> bool

        bool
        LOCA::ParameterVector::update(double alpha, const ParameterVector
        &alphaVector, double b)

        Updates the parameter vector: this = alpha * alphaVector + b * this.
        Returns true if successful. 
        """
        return _Parameter.ParameterVector_update(self, *args)


    def setValue(self, *args):
        """
        setValue(ParameterVector self, unsigned int i, double value)
        setValue(ParameterVector self, std::string label, double value)

        void
        LOCA::ParameterVector::setValue(std::string label, double value)

        Set the value of the parameter with the corresponding label. Will
        throw an error if "label" is not valid. 
        """
        return _Parameter.ParameterVector_setValue(self, *args)


    def getValue(self, *args):
        """
        getValue(ParameterVector self, unsigned int i) -> double
        getValue(ParameterVector self, std::string label) -> double

        double
        LOCA::ParameterVector::getValue(std::string label) const

        Returns the value of the parameter with the corresponding label. Will
        throw an error if "label" is not valid. 
        """
        return _Parameter.ParameterVector_getValue(self, *args)


    def getIndex(self, *args):
        """
        getIndex(ParameterVector self, std::string label) -> int

        int
        LOCA::ParameterVector::getIndex(std::string label) const

        Returns the index of the parameter with the corresponding label.
        Returns a -1 if "label" is not found. 
        """
        return _Parameter.ParameterVector_getIndex(self, *args)


    def getDoubleArrayPointer(self, *args):
        """
        getDoubleArrayPointer(ParameterVector self) -> double *

        double * LOCA::ParameterVector::getDoubleArrayPointer()

        Returns a pointer to a C-style array of the parameter values. 
        """
        return _Parameter.ParameterVector_getDoubleArrayPointer(self, *args)


    def isParameter(self, *args):
        """
        isParameter(ParameterVector self, std::string label) -> bool

        bool
        LOCA::ParameterVector::isParameter(std::string label) const

        Returns true if the parameter std::string "label" corresponds to a
        parameter label in the object. 
        """
        return _Parameter.ParameterVector_isParameter(self, *args)


    def getLabel(self, *args):
        """
        getLabel(ParameterVector self, unsigned int i) -> std::string

        std::string
        LOCA::ParameterVector::getLabel(unsigned int i) const

        Returns the label of the parameter with index i. 
        """
        return _Parameter.ParameterVector_getLabel(self, *args)


    def length(self, *args):
        """
        length(ParameterVector self) -> int

        int
        LOCA::ParameterVector::length() const

        Returns the length of parameter vector. 
        """
        return _Parameter.ParameterVector_length(self, *args)


    def getValuesVector(self, *args):
        """
        getValuesVector(ParameterVector self) -> std::vector< double,std::allocator< double > > const &

        const
        std::vector< double > & LOCA::ParameterVector::getValuesVector() const

        Accessor to get the underlying stl vector with all parameter values.

        """
        return _Parameter.ParameterVector_getValuesVector(self, *args)


    def getNamesVector(self, *args):
        """
        getNamesVector(ParameterVector self) -> std::vector< std::string,std::allocator< std::string > > const &

        const
        std::vector< std::string > & LOCA::ParameterVector::getNamesVector()
        const

        Accessor to get the underlying stl vector with all parameter names. 
        """
        return _Parameter.ParameterVector_getNamesVector(self, *args)

ParameterVector_swigregister = _Parameter.ParameterVector_swigregister
ParameterVector_swigregister(ParameterVector)


def __lshift__(*args):
    """__lshift__(std::ostream & stream, ParameterVector p) -> std::ostream &"""
    return _Parameter.__lshift__(*args)
# This file is compatible with both classic and new-style classes.


